#include "Mydefs.h"
#include "mem_wrappers.h"
#include <string.h>

int hex_value(char hex_char);

char *html_to_text(const char *orig_text) {

}

char *cgi_to_text(const char *cgi_text) {
	char result[MAX_STRING];
	int ascii_num;
	int i, j, k, l;
	for (i=0, j=0; i<strlen(cgi_text) && j<MAX_STRING; i++,j++) {
		if(cgi_text[i]=='+') {
			result[j]=' ';
			continue;
		}
		if(cgi_text[i]=='%') {
			ascii_num=0;
			for(k=0; k<2; k++) {
				i++;
				if( (l = hex_value(cgi_text[i])) <0) {
					return(NULL);
				}
				ascii_num+=l*((k>0)?1:16);
			}
			result[j]=ascii_num;
			continue;
		}
		result[j]=cgi_text[i];
	}
	result[j]='\0';
	return(Strdup(result));
}

char *text_to_html(const char *orig_text) {
	char result[MAX_STRING];
	int i, j;
	int newline;

	newline=1;
	for (i=0, j=0; i<strlen(orig_text) && j<MAX_STRING; i++, j++) {
		if (newline) {
			while(orig_text[i]==' ' && j+6<MAX_STRING) {
				result[j++]='&';
				result[j++]='n';
				result[j++]='b';
				result[j++]='s';
				result[j++]='p';
				result[j++]=';';
				i++;
			}
			newline=0;
		}
		if (orig_text[i]=='\n') {
			newline=1;
			if (j+4<MAX_STRING) {
				result[j++]='<';
				result[j++]='B';
				result[j++]='R';
				result[j]='>';
			}
			continue;
		}
		if (orig_text[i]=='<' && j+4<MAX_STRING) {
			result[j++]='&';
			result[j++]='l';
			result[j++]='t';
			result[j]=';';
			continue;
		}
		result[j]=orig_text[i];
	}
	result[j]='\0';
	return(Strdup(result));
}

int hex_value(char hex_num) {

	if(hex_num>=48 && hex_num<=57) {  // numbah
		return(hex_num-48);
	}
	if(hex_num>=65 && hex_num<=70) {  // lettah
		return(hex_num-65+10);
	}
	return(-1);
}
