#include <stdlib.h>
#include <string.h>
#include "errors.h"


void *Malloc(size_t size) {
	void *return_value;
	if ((return_value=malloc(size))==NULL) {
		fatal_error("Server Error. Try later and if the problem persists contact the system administrator");
	}
	return(return_value);
}

char *Strdup(const char *s) {
	char *return_value;
	if ((return_value=strdup(s))==NULL) {
		fatal_error("Server Error. Try later and if the problem persists contact the system administrator");
	}
	return(return_value);
}
