#include "Mydefs.h"
#include <string.h>
#include "mem_wrappers.h"
#include "various_functions.h"
#include "msg_queries.h"
#include <sys/types.h>
#include <sys/unistd.h>

char *new_msg_no(void) {  // HEAVILY DEPENDENT UPON SIZE_OF_MSG_NO-SIZE_OF_TIME
	char *cur_time;
	int i, j;

	cur_time=get_time();
	for (i=0; i< 10; i++) {
		for (j=0; j<10; j++) {
			cur_time[SIZE_OF_TIME]=48+i;
			cur_time[SIZE_OF_TIME+1]=48+j;
			if (get_msg(cur_time)==NULL) {
				return (cur_time);
			}
		}
	}
	return(NULL);
}

//This one does create a key. This must be done elsewhere
char *format_new_msg(const char *FromWhom,const char *Subject,const char *Text){
	char *message;
	char *null_msg_no;
	int i;
	int length;

	length= 3*SIZE_OF_MSG_NO+MAX_SIZE_OF_WHO+MAX_SIZE_OF_SUBJECT+ 
		MAX_SIZE_OF_TEXT+strlen(FromWhom)+strlen(Subject)+strlen(Text);
	message=(char *)Malloc(length+1);
	message[length]='\0';

	null_msg_no=make_null_msg_no(3*SIZE_OF_MSG_NO);
	strncpy(message, null_msg_no, 3*SIZE_OF_MSG_NO);
	message[3*SIZE_OF_MSG_NO]='\0';
	free(null_msg_no);
	null_msg_no=(char *)Malloc(MAX_SIZE_OF_WHO+1);
	if(perfect_fit(null_msg_no, strlen(FromWhom), MAX_SIZE_OF_WHO)<0) {
		return (NULL);
	}
	null_msg_no[MAX_SIZE_OF_WHO]='\0';
	strncat(message, null_msg_no, MAX_SIZE_OF_WHO);	
	free(null_msg_no);
	strncat(message, FromWhom, strlen(FromWhom));
	null_msg_no=(char *)Malloc(MAX_SIZE_OF_SUBJECT+1);
	if(perfect_fit(null_msg_no, strlen(Subject), MAX_SIZE_OF_SUBJECT)<0){
		return(NULL);
	}
	null_msg_no[MAX_SIZE_OF_SUBJECT]='\0';
	strncat(message, null_msg_no, MAX_SIZE_OF_SUBJECT);
	free(null_msg_no);
	strncat(message, Subject, strlen(Subject));

	null_msg_no=(char *)Malloc(MAX_SIZE_OF_TEXT+1);
	if(perfect_fit(null_msg_no, strlen(Text), MAX_SIZE_OF_TEXT)<0){
		return(NULL);
	}
	null_msg_no[MAX_SIZE_OF_TEXT]='\0';
	strncat(message, null_msg_no, MAX_SIZE_OF_TEXT);
	free(null_msg_no);
	strncat(message, Text, strlen(Text));
	return(message);
}

int put_null_header(int fd) {
	char *to_be_freed;

	if(lseek(fd, 0, SEEK_SET)<0) {
		return(-1);
	}
	if((to_be_freed=make_null_msg_no(2*SIZE_OF_MSG_NO+1))==NULL) {
		return(-1);
	}
	if(write(fd, to_be_freed, 2*SIZE_OF_MSG_NO)<2*SIZE_OF_MSG_NO) {
		return(-1);
	}
	return(1);
}

